zoukankan      html  css  js  c++  java
  • HDU 5389 Zero Escape(dp啊 多校)

    题目链接:http://acm.hdu.edu.cn/showproblem.php?

    pid=5389


    Problem Description
    Zero Escape, is a visual novel adventure video game directed by Kotaro Uchikoshi (you may hear about ever17?) and developed by Chunsoft.

    Stilwell is enjoying the first chapter of this series, and in this chapter digital root is an important factor. 

    This is the definition of digital root on Wikipedia:
    The digital root of a non-negative integer is the single digit value obtained by an iterative process of summing digits, on each iteration using the result from the previous iteration to compute a digit sum. The process continues until a single-digit number is reached.
    For example, the digital root of 65536 is 7, because 6+5+5+3+6=25 and 2+5=7.

    In the game, every player has a special identifier. Maybe two players have the same identifier, but they are different players. If a group of players want to get into a door numbered X(1X9), the digital root of their identifier sum must be X.
    For example, players {1,2,6} can get into the door 9, but players {2,3,3} can't.

    There is two doors, numbered A and B. Maybe A=B, but they are two different door.
    And there is n players, everyone must get into one of these two doors. Some players will get into the door A, and others will get into the door B.
    For example: 
    players are {1,2,6}A=9B=1
    There is only one way to distribute the players: all players get into the door 9. Because there is no player to get into the door 1, the digital root limit of this door will be ignored.

    Given the identifier of every player, please calculate how many kinds of methods are there, mod 258280327.
     

    Input
    The first line of the input contains a single number T, the number of test cases.
    For each test case, the first line contains three integers nA and B.
    Next line contains n integers idi, describing the identifier of every player.
    T100n105n1061A,B,idi9
     

    Output
    For each test case, output a single integer in a single line, the number of ways that these n players can get into these two doors.
     

    Sample Input
    4 3 9 1 1 2 6 3 9 1 2 3 3 5 2 3 1 1 1 1 1 9 9 9 1 2 3 4 5 6 7 8 9
     

    Sample Output
    1 0 10 60
     

    Source


    题意:(转)

    一个长度为 n 的序列分为两组,使得一组的和为A,一组的和为B.

    求有多少种分法!

    PS:

    注意这里的和定义为这些数的和的数根。

    一个数的数根的计算公式为,root = (x-1)%9+1;

    非常明显一个正整数的数根是1~9的分析,假设这n个数的数根分成两组使得

    一组的数根为A,一组的数根为B那么这两组的数的和的数根等于(A+B)的

    数根。

    因此我们仅仅须要考虑组成当中一个数的情况。然后再最后进行一个

    推断就可以我们设dp[i][j]表示前i个数组成的数根为j的数目。

    注意当中随意一组能够为空。

    代码例如以下:

    #include <cstdio>
    #include <cstring>
    const int mod = 258280327;
    #define maxn 100017
    int dp[maxn][10];
    //dp[i][j]:前i个数能组成j的方案数
    
    int num[maxn];
    int cal(int x, int y)
    {
        int tmp = x+y;
        int ans = tmp%9;
        if(ans == 0)
        {
            return 9;
        }
        return ans;
    }
    int main()
    {
        int t;
        int n, a, b;
        scanf("%d",&t);
        while(t--)
        {
            int sum = 0;
            memset(dp,0,sizeof(dp));
            scanf("%d%d%d",&n,&a,&b);
            for(int i = 1; i <= n; i++)
            {
                scanf("%d",&num[i]);
                sum = cal(sum,num[i]);
            }
            dp[0][0] = 1;
            for(int i = 1; i <= n; i++)
            {
                for(int j = 0; j <= 9; j++)
                {
                    dp[i][j]+=dp[i-1][j];
                    dp[i][j]%=mod;
                    int tt = cal(num[i],j);
                    dp[i][tt]+=dp[i-1][j];
                    dp[i][tt]%=mod;
                }
            }
            int ans = 0;
            if(cal(a, b) == sum)
            {
                ans+=dp[n][a];
                if(a == sum)
                {
                    ans--;
                }
            }
            if(sum == a)//都分给a
            {
                ans++;
            }
            if(sum == b)//都分给b
            {
                ans++;
            }
            printf("%d
    ",ans);
        }
        return 0;
    }
    


  • 相关阅读:
    金步国作品列表
    GCC编译优化指南【作者:金步国】
    g++优化选项
    C++中实现对map按照value值进行排序
    C++ STL中Map的相关排序操作:按Key排序和按Value排序
    How-To: add EPEL repository to Centos 6.x is Easy!
    如何为linux释放内存和缓存
    用Python对体积较大的CSV文件进行比较的经验
    The mmap module
    Python逐块读取大文件行数的代码
  • 原文地址:https://www.cnblogs.com/gavanwanggw/p/7327143.html
Copyright © 2011-2022 走看看